---
layout: markdown_page
title: "Category Direction - Runner Core"
description: "This is the Product Direction Page for the Runner Core product category."
canonical_path: "/direction/verify/runner_core/"
---

## Navigation & Settings

|                       |                               |
| -                     | -                             |
| Stage                 | [Verify](/direction/verify/)  |
| Maturity              | Lovable |
| Content Last Reviewed | `2023-06-03`                  |

### Introduction and how you can help

Thanks for visiting this direction page on the Runner Core category at GitLab. This page belongs to the [Runner Group](https://about.gitlab.com/handbook/product/categories/#runner-group) within the Verify Stage and is maintained by [Darren Eastman](mailto:deastman@gitlab.com).

### Strategy and Themes

GitLab Runner -  the near-ubiquitous build agent that executes CI jobs on a target compute platform is a critical foundational pillar of GitLab's [one DevSecOps platform vision](https://about.gitlab.com/direction/#vision). The fundamental problems customers must solve in this product category include installing, configuring, and scaling CI/CD build agents (runners) on public cloud infrastructure and securely executing CI/CD jobs on heterogeneous computing environments.

Organizations that adopt the GitLab one DevSecOps platform approach [realize](https://about.gitlab.com/resources/report-forrester-tei/) significant gains in development and delivery efficiency. With GitLab's new [AI/ML](https://about.gitlab.com/blog/2023/04/24/ai-ml-in-devsecops-series/) feature sets, we expect an order of magnitude increase in developer efficiency and reduced time to market for software-enabled technology changes.

Self-managed GitLab customers must consider, plan for, and operate CI/CD computing for builds at an enormous scale. And this is where the core GitLab Runner application and strategy comes in. We aim to ensure that as AI integrates more into development processes, organizations can efficiently and cost-effectively scale up to meet the ever-increasing demand for computing. This thinking is at the heart of the investments described below for FY24 in autoscaling, whether on Kubernetes or public cloud virtual machine instances with the [GitLab Runner Autoscaling solution](https://docs.gitlab.com/runner/runner_autoscale/).

### 1 year plan

The FY24 product themes for Runner Core mapped to GitLab's FY24 product investment themes are as follows.

**World-class DevSecOps experience**:

- [Next Runner Token Architecture](https://docs.gitlab.com/ee/architecture/blueprints/runner_tokens/#next-gitlab-runner-token-architecture)
- [Next Runner Autoscaling](https://docs.gitlab.com/ee/architecture/blueprints/runner_scaling/#next-runner-auto-scaling-architecture)
  - [Autoscaling on AWS EC2 instances](https://gitlab.com/groups/gitlab-org/-/epics/8856)
  - [Autoscaling on Google Compute Engine](https://gitlab.com/groups/gitlab-org/-/epics/9358)
  - [Autoscaling on Azure Virtual Machines](https://gitlab.com/groups/gitlab-org/-/epics/9359)
- [Kubernetes Executor - FY24](https://gitlab.com/groups/gitlab-org/-/epics/8394)

**Advanced security and compliance**

- Software Supply Chain Security - [Native Signing of Build Artifacts](https://gitlab.com/groups/gitlab-org/-/epics/9212)

### What is next for us
<!-- This is a 3 month look ahead for the next iteration that you have planned for the category. This section must provide links to issues or
or to [epics](https://about.gitlab.com/handbook/product/product-processes/#epics-for-a-single-iteration) that are scoped to a single iteration. Please do not link to epics encompass a vision that is a longer horizon and don't lay out an iteration plan. -->

In the next three months (July to September 2023) we plan to deliver these critical features:

**Next Runner Autoscaling:**

- [GitLab Runner Fleeting Plugin for GCP Compute Engine -  BETA](https://gitlab.com/gitlab-org/gitlab-runner/-/issues/29409)
- [GitLab Runner Fleeting plugin for Azure Virtual Machines - BETA](https://gitlab.com/gitlab-org/gitlab-runner/-/issues/29410)
- [GitLab Runner Fleeting plugin for AWS EC2 instances - GA](https://gitlab.com/gitlab-org/gitlab-runner/-/issues/29222)


### What we are currently working on
<!-- Scoped to the current month. This section can contain the items that you choose to highlight on the kickoff call. Only link to issues, not Epics.  -->

While the main focus area is the work required to deliver the [new GitLab Runner autoscaling solution](https://docs.gitlab.com/runner/runner_autoscale/#gitlab-runner-autoscaling) on instances provided by the major public cloud providers, new feature additions are also in the works for runner autoscaling on Kubernetes. The primary feature under development is [adding support for Pod affinity and anti-affinity](https://gitlab.com/gitlab-org/gl-openshift/gitlab-runner-operator/-/issues/98) to the Runner Operator for Kubernetes.

### What we recently completed
<!-- Lookback limited to 3 months. Link to the relevant issues or release post items. -->

- [GitLab Runner Fleeting plugin for AWS EC2 instances - Experimental](https://gitlab.com/gitlab-org/gitlab-runner/-/issues/29219)
- [GitLab Runner Autoscaling - Windows Container Builds](https://gitlab.com/gitlab-org/gitlab-runner/-/issues/29598)
- [GitLab Runner Auto-scaling: Fleeting plugin for Google Compute Engine - Experiment.](https://gitlab.com/gitlab-org/gitlab-runner/-/issues/29217)

### What is Not Planned Right Now

We are not actively working on the following features:

- [Runner Priority](https://gitlab.com/gitlab-org/gitlab/-/issues/14976) - This is a very popular feature proposal in the Runner core product backlog to address the need to route CI jobs to an available or less busy Runner. Work on a solution to the problems outlined in this issue is not prioritized for the FY24 roadmap. There is likely an added layer of complexity as routing CI jobs to a runner involves the GitLab CI job queueing mechanism.

- [Access control list for instance runners](https://gitlab.com/gitlab-org/gitlab/-/issues/378322). This feature solves security, compliance, and organizational policy requirement problems for self-managed customers. While we are not actively developing this feature, we have started an [architectural blueprint](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/113923) for a new feature to solve the problem - the runner admissions controller solution. The goal is to document a technical approach that can guide community contributions for delivering an MVC.

- [Sticky Runners](https://gitlab.com/gitlab-org/gitlab/-/issues/17497) - For this feature, the problem to solve is that users need to improve CI job performance in scenarios where each job can generate intermediate build elements with hundreds of GBs in size. In the current GitLab CI model, a significant amount of pipeline execution time is due to the uploading and downloading of intermediate build elements between jobs in a pipeline. Given the current Runner executor implementation, i.e., we support several executor types out of the box (shell, docker, Kubernetes), changing the CI job execution paradigm in GitLab is a significant architectural change. The Sticky Runners MVC feature is not in the FY24 roadmap due to higher priority features in the Runner core and the Verify stage.

### Best in Class Landscape
<!-- Blanket description consistent across all pages that clarifies what GitLab means when we say "best in class" -->

BIC (Best In Class) is an indicator of forecasted near-term market performance based on a combination of factors, including analyst views, market news, and feedback from the sales and product teams. It is critical that we understand where GitLab appears in the BIC landscape.

#### Key Capabilities

When you run a continuous integration pipeline job or workflow, the code in that pipeline must execute on some computing platform to complete your software's building, testing, and deployment. Terms used to describe the software that handles the pipeline code execution include worker, agent, or runner.

So while the basic functionality of pipeline code execution is table stakes in the industry, the ability to efficiently build software on multiple compute platforms with low operational maintenance overhead are critical features for a best-in-class solution.

#### Roadmap

Using autoscaling GitLab Runners, you can provide a build environment that efficiently handles vast volumes of CI/Cd jobs while maintaining your internal SLOs for job start time and build performance. In FY24, the critical focus area for achieving best-in-class is Next Runner Autoscaling on the major public cloud providers' virtual machine solutions. This feature set will replace the legacy autoscaling solution based on Docker Machine. A critical goal of GitLab Runner Autoscaling is to provide customers with a simple-to-use solution for cost-effectively scaling a Runner Fleet on a target Infrastructure as a Service (Iaas) platform that offers virtual machines or instances on demand.


#### Top [1/2/3] Competitive Solutions

| Solution | CI/CD Agent naming convention/brand |Self-Managed Option Availablity|Notes|
| ------ | ------ |------ |------ |
|GitHub Actions| Runners |Available|GitHub released self-hosted runners in late 2019. Since then, GitHub has continued to invest in features and capabilities. We also notice similar investment themes as GitHub continues to target market segments requiring a self-managed platform. For example, GitHub self-hosted runners have added support for Apple M1 silicon. GitHub is also investing in self-hosted runner auto-scaling with plans to add support for Kubernetes in CY23-Q1. The autoscaling roadmap issue also includes an interesting note about queue visibility and tooling to deploy runners from the UI, which is very much related to our vision for zero friction runners.|
|Jenkins|Agents|Available|In Jenkins, an agent is a software executable that runs a task under the direction of the Jenkins controller.  Like GitLab Runner, a Jenkins agent can run on different computing environments (bare metal, virtual machines, containers, Kubernetes clusters).  Java must be supported and installed on the host OS to run a Jenkins agent. |
| Harness.io   | Harness Delegate                          |Available| Harness currently provides the following types of Delegate: Kubernetes, Shell Script, AWS ECS, Helm, Docker. Though the Delegates perform a similar essential function as GitLab Runner, i.e., executes tasks provided by the Harness Manager, the Delegates' primary purpose is to deploy software to the target platform. In this regard, the value proposition of the [GitLab Agent for Kubernetes](https://docs.gitlab.com/ee/user/clusters/agent/) is a critical consideration when evaluating capabilities in GitLab for developer frictionless cloud-native deployment.

### Maturity Plan

- Runner core is at the "Lovable" maturity level (see our [definitions of maturity levels](/direction/maturity/)).
- As detailed in this [epic](https://gitlab.com/groups/gitlab-org/-/epics/6090), we plan to review the maturity scorecard for runner core and complete new category maturity scorecards for the other product development categories, runner cloud, and fleet management.
